searchNodes=[{"ref":"TelemetryMetricsPrometheus.Core.html","title":"TelemetryMetricsPrometheus.Core","type":"module","doc":"Prometheus Reporter for Telemetry.Metrics definitions. Provide a list of metric definitions to the child_spec/1 function. It&#39;s recommended to add this to your supervision tree. def start(_type, _args) do # List all child processes to be supervised children = [ {TelemetryMetricsPrometheus.Core, [ metrics: [ counter(&quot;http.request.count&quot;), sum(&quot;http.request.payload_size&quot;, unit: :byte), last_value(&quot;vm.memory.total&quot;, unit: :byte) ] ]} ] opts = [strategy: :one_for_one, name: ExampleApp.Supervisor] Supervisor.start_link(children, opts) end Note that aggregations for distributions (histogram) only occur at scrape time. These aggregations only have to process events that have occurred since the last scrape, so it&#39;s recommended at this time to keep an eye on scrape durations if you&#39;re reporting a large number of distributions or you have a high tag cardinality. Telemetry.Metrics to Prometheus Equivalents Metric types: Counter - Counter Distribution - Histogram LastValue - Gauge Sum - Counter Summary - Summary (Not supported) Units Prometheus recommends the usage of base units for compatibility - Base Units. This is simple to do with :telemetry and Telemetry.Metrics as all memory related measurements in the BEAM are reported in bytes and Metrics provides automatic time unit conversions. Note that measurement unit should used as part of the reported name in the case of histograms and gauges to Prometheus. As such, it is important to explicitly define the unit of measure for these types when the unit is time or memory related. It is suggested to not mix units, e.g. seconds with milliseconds. It is required to define your buckets according to the end unit translation since this measurements are converted at the time of handling the event, prior to bucketing. Memory Report memory as :byte. Time Report durations as :second. The BEAM and :telemetry events use :native time units. Converting to seconds is as simple as adding the conversion tuple for the unit - {:native, :second} Naming Telemetry.Metrics definition names do not translate easily to Prometheus naming conventions. By default, the name provided when creating your definition uses parts of the provided name to determine what event to listen to and which event measurement to use. For example, &quot;http.request.duration&quot; results in listening for [:http, :request] events and use :duration from the event measurements. Prometheus would recommend a name of http_request_duration_seconds as a good name. It is therefore recommended to use the name in your definition to reflect the name you wish to see reported, e.g. http.request.duration.seconds or [:http, :request, :duration, :seconds] and use the :event_name override and :measurement options in your definition. Example: Metrics.distribution( &quot;http.request.duration.seconds&quot;, buckets: [0.01, 0.025, 0.05, 0.1, 0.2, 0.5, 1], event_name: [:http, :request, :complete], measurement: :duration, unit: {:native, :second} ) The exporter sanitizes names to Prometheus&#39; requirements (Metric Naming) and joins the event name parts with an underscore. Labels Labels in Prometheus are referred to as :tags in Telemetry.Metrics - see the docs for more information on tag usage. Important: Each tag + value results in a separate time series. For distributions, this is further complicated as a time series is created for each bucket plus one for measurements exceeding the limit of the last bucket - +Inf. It is recommended, but not required, to abide by Prometheus&#39; best practices regarding labels - Label Best Practices"},{"ref":"TelemetryMetricsPrometheus.Core.html#child_spec/1","title":"TelemetryMetricsPrometheus.Core.child_spec/1","type":"function","doc":"Reporter&#39;s child spec. This function allows you to start the reporter under a supervisor like this: children = [ {TelemetryMetricsPrometheus.Core, options} ] See start_child/1 for options."},{"ref":"TelemetryMetricsPrometheus.Core.html#scrape/1","title":"TelemetryMetricsPrometheus.Core.scrape/1","type":"function","doc":"Returns a metrics scrape in Prometheus exposition format for the given reporter name - defaults to :prometheus_metrics."},{"ref":"TelemetryMetricsPrometheus.Core.html#start_link/1","title":"TelemetryMetricsPrometheus.Core.start_link/1","type":"function","doc":"Start the TelemetryMetricsPrometheus.Core.Supervisor Available options: :name - name of the reporter instance. Defaults to :prometheus_metrics :monitor_reporter - collects metrics on the reporter&#39;s ETS table usage. Defaults to false :validations - Keyword options list to control validations. All validations can be disabled by setting validations: false. :consistent_units - logs a warning when mixed time units are found in your definitions. Defaults to true :require_seconds - logs a warning if units other than seconds are found in your definitions. Defaults to true :metrics - a list of metrics to track."},{"ref":"TelemetryMetricsPrometheus.Core.html#t:metric/0","title":"TelemetryMetricsPrometheus.Core.metric/0","type":"type","doc":""},{"ref":"TelemetryMetricsPrometheus.Core.html#t:metrics/0","title":"TelemetryMetricsPrometheus.Core.metrics/0","type":"type","doc":""},{"ref":"TelemetryMetricsPrometheus.Core.html#t:prometheus_option/0","title":"TelemetryMetricsPrometheus.Core.prometheus_option/0","type":"type","doc":""},{"ref":"TelemetryMetricsPrometheus.Core.html#t:prometheus_options/0","title":"TelemetryMetricsPrometheus.Core.prometheus_options/0","type":"type","doc":""},{"ref":"TelemetryMetricsPrometheus.Core.ReporterSupervisor.html","title":"TelemetryMetricsPrometheus.Core.ReporterSupervisor","type":"module","doc":""},{"ref":"TelemetryMetricsPrometheus.Core.ReporterSupervisor.html#child_spec/1","title":"TelemetryMetricsPrometheus.Core.ReporterSupervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"TelemetryMetricsPrometheus.Core.ReporterSupervisor.html#start_link/1","title":"TelemetryMetricsPrometheus.Core.ReporterSupervisor.start_link/1","type":"function","doc":""},{"ref":"overview.html","title":"Overview","type":"extras","doc":"Overview TelemetryMetricsPrometheus.Core is a Telemetry.Metrics Reporter for aggregating and exposing Prometheus metrics based on Telemetry.Metrics definitions. The reporter runs as a supervised process but does not include a web server to expose your metrics. TelemetryMetricsPrometheus provides an out of the box solution with an included web server."},{"ref":"overview.html#getting-started","title":"Overview - Getting Started","type":"extras","doc":"Once you have the package added to your dependencies, you can start TelemetryMetricsPrometheus.Core by initiating the application during your application startup. def start(_type, _args) do # List all child processes to be supervised children = [ {TelemetryMetricsPrometheus.Core, [metrics: metrics()]} ... ] opts = [strategy: :one_for_one, name: ExampleApp.Supervisor] Supervisor.start_link(children, opts) end defp metrics, do: [ counter(&quot;http.request.count&quot;), sum(&quot;http.request.payload_size&quot;, unit: :byte), last_value(&quot;vm.memory.total&quot;, unit: :byte) ] There are a few metrics built into TelemetryMetricsPrometheus.Core to monitor resource usage by the reporter and measure scrape processing time. To see it in action, fire up your application in your terminal iex -S mix. &gt; TelemetryMetricsPrometheus.Core.scrape() # HELP prometheus_metrics_table_size_total A gauge of the key count of a prometheus metrics aggregation table # TYPE prometheus_metrics_table_size_total gauge prometheus_metrics_table_size_total{name=&quot;prometheus_metrics_dist&quot;} 1 prometheus_metrics_table_size_total{name=&quot;prometheus_metrics&quot;} 4 # HELP prometheus_metrics_table_memory_bytes A gauge of the memory size of a prometheus metrics aggregation table # TYPE prometheus_metrics_table_memory_bytes gauge prometheus_metrics_table_memory_bytes{name=&quot;prometheus_metrics_dist&quot;} 1356 prometheus_metrics_table_memory_bytes{name=&quot;prometheus_metrics&quot;} 1426 # HELP prometheus_metrics_scrape_duration_seconds A histogram of the request duration for prometheus metrics scrape. # TYPE prometheus_metrics_scrape_duration_seconds histogram prometheus_metrics_scrape_duration_seconds_bucket{name=&quot;prometheus_metrics&quot;,le=&quot;0.05&quot;} 1 prometheus_metrics_scrape_duration_seconds_bucket{name=&quot;prometheus_metrics&quot;,le=&quot;0.1&quot;} 1 prometheus_metrics_scrape_duration_seconds_bucket{name=&quot;prometheus_metrics&quot;,le=&quot;0.2&quot;} 1 prometheus_metrics_scrape_duration_seconds_bucket{name=&quot;prometheus_metrics&quot;,le=&quot;0.5&quot;} 1 prometheus_metrics_scrape_duration_seconds_bucket{name=&quot;prometheus_metrics&quot;,le=&quot;1&quot;} 1 prometheus_metrics_scrape_duration_seconds_bucket{name=&quot;prometheus_metrics&quot;,le=&quot;+Inf&quot;} 1 prometheus_metrics_scrape_duration_seconds_sum{name=&quot;prometheus_metrics&quot;} 0.00213792 prometheus_metrics_scrape_duration_seconds_count{name=&quot;prometheus_metrics&quot;} 1 Note that aggregations for distributions (histogram) only occur at scrape time. These aggregations only have to process events that have occurred since the last scrape, so it&#39;s recommended at this time to keep an eye on scrape durations if you&#39;re reporting a large number of disributions or you have a high tag cardinality."},{"ref":"overview.html#telemetry-metrics-to-prometheus-equivalents","title":"Overview - Telemetry.Metrics to Prometheus equivalents","type":"extras","doc":"Metric types: Counter - Counter Distribution - Histogram LastValue - Gauge Sum - Counter Summary - Summary (Not supported) Units Prometheus recommends the usage of base units for compatibility - Base Units. This is simple to do with :telemetry and Telemetry.Metrics as all memory related measurements in the BEAM are reported in bytes and Metrics provides automatic time unit conversions. Note that measurement unit should used as part of the reported name in the case of histograms and gauges to Prometheus. As such, it is important to explicitly define the unit of measure for these types when the unit is time or memory related. It is suggested to not mix units, e.g. seconds with milliseconds. It is required to define your buckets according to the end unit translation since this measurements are converted at the time of handling the event, prior to bucketing. Memory Report memory as :byte. Time Report durations as :second. The BEAM and :telemetry events use :native time units. Converting to seconds is as simple as adding the conversion tuple for the unit - {:native, :second} Naming Telemetry.Metrics definition names do not translate easily to Prometheus naming conventions. By default, the name provided when creating your definition uses parts of the provided name to determine what event to listen to and which event measurement to use. For example, &quot;http.request.duration&quot; results in listening for [:http, :request] events and use :duration from the event measurements. Prometheus would recommend a name of &quot;http_request_duration_seconds&quot; as a good name. It is therefore recommended to use the name in your definition to reflect the name you wish to see reported, e.g. &quot;http.request.duration.seconds&quot; or [:http, :request, :duration, :seconds] and use the :event_name override and :measurement options in your definition. Example: Metrics.distribution( &quot;http.request.duration.seconds&quot;, buckets: [0.01, 0.025, 0.05, 0.1, 0.2, 0.5, 1], event_name: [:http, :request, :complete], measurement: :duration, unit: {:native, :second} ) The exporter sanitizes names to Prometheus&#39; requirements Naming and joins the event name parts with an underscore. Labels Labels in Prometheus are referred to as :tags in Telemetry.Metrics - see the docs for more information on tag usage. Important: Each tag + value results in a separate time series. For distributions, this is further complicated as a time series is created for each bucket plus one for measurements exceeding the limit of the last bucket - +Inf. It is recommended, but not required, to abide by Prometheus&#39; best practices regarding labels - Label Best Practices Included Metrics Several metrics are exported by default to monitor scrape metrics. The metric names are: &quot;prometheus_metrics_scrape_duration_seconds&quot; &quot;prometheus_metrics_aggregation_duration_seconds&quot; Optionally, you can monitor internal :ets table usage by setting monitor_reporter: true in your init options. The metric names for this setting are: &quot;prometheus_metrics_table_memory_bytes&quot; &quot;prometheus_metrics_table_size_total&quot; Please report any abnormally large table usage. Histogram measurements are currently only aggregated at the time of the scrape. We can take a different approach if this proves to be an issue."}]